﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CatalexLib;

namespace CatalexTester
{
    public partial class Form1 : Form
    {
        CatalexBoard _cb = null;
        public Form1()
        {
            InitializeComponent();
            cbSer.DataSource = System.IO.Ports.SerialPort.GetPortNames();
            cbCmd.DataSource = Enum.GetNames(typeof (CatalexCmd));
            cbQuery.DataSource = Enum.GetNames(typeof (CatalexQueryCmd));
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            if (cbSer.SelectedIndex < 0)
            {
                MessageBox.Show("Pick a port");
                return;
            }

            try
            {
                _cb = new CatalexBoard(cbSer.Text);
                _cb.NewMessage += new CatalexBoard.NewMessageEventHandler(_cb_NewMessage);
                _cb.Start();
                btnStart.Enabled = false;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        void _cb_NewMessage(string msg)
        {
            SetText(msg);
        }
        delegate void SetTextCallback(string text);
        private void SetText(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.txtMsgs.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(SetText);
                this.Invoke(d, new object[] { text });
                //if (text.Contains("SERVO[0]"))
                //{
                //    //try to parse this
                //    string[] lines = text.Split(new string[] { Environment.NewLine }, StringSplitOptions.None);

                //}
            }
            else
            {
                 this.txtMsgs.Text += text;
                 this.txtMsgs.SelectionStart = this.txtMsgs.Text.Length;
                 this.txtMsgs.ScrollToCaret();
            }
        }

        private void btnCmd_Click(object sender, EventArgs e)
        {
            if (_cb == null) return;
            CatalexCmd c = (CatalexCmd)Enum.Parse(typeof(CatalexCmd),cbCmd.Text);
            _cb.sendCommand(c, Convert.ToByte(txtHi.Text),Convert.ToByte(txtLow.Text), chkFeedback.Checked);
        }

        private void btnQuery_Click(object sender, EventArgs e)
        {
            if (_cb == null) return;
            CatalexQueryCmd cq = (CatalexQueryCmd)Enum.Parse(typeof(CatalexQueryCmd), cbQuery.Text);
            _cb.sendQCommand(cq, Convert.ToByte(txtFolder.Text));
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (_cb != null)
                _cb.Stop();
        }

        //private void button1_Click(object sender, EventArgs e)
        //{
        //    if (_cb == null) return;
        //    _cb.test1();
        //}

    }
}
